unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Disptch, ExtCtrls,
  Unit2, Grids, Buttons;

type
  TForm1 = class(TForm)
    { S - select, Q - Queue, E - Execute }
    Dsp: TDispatcher;
    GroupBox1: TGroupBox;
    LabelS1: TLabel;
    LabelS2: TLabel;
    ListBoxS1: TListBox;
    ImageS1: TImage;
    GroupBox2: TGroupBox;
    LabelQ1: TLabel;
    LabelQ2: TLabel;
    EditQ1: TEdit;
    EditQ2: TEdit;
    ButtonS3: TButton;
    ButtonS4: TButton;
    LabelQ5: TLabel;
    ListBoxS2: TListBox;
    ListBoxS3: TListBox;
    LabelS3: TLabel;
    DrawGridQ1: TDrawGrid;
    LabelS4: TLabel;
    LabelS5: TLabel;
    LabelS6: TLabel;
    BitBtnAdd: TBitBtn;
    BitBtnDel: TBitBtn;
    procedure FormShow(Sender: TObject);
    procedure QueueChange(Sender: TObject);
    procedure DisplayEnabled;
    procedure ButtonS1Click(Sender: TObject);
    procedure ListBoxS1Click(Sender: TObject);
    procedure DspDispatch(Sender: TObject; Ident: String; Environ: TObject);
    procedure ButtonS3Click(Sender: TObject);
    procedure ButtonS4Click(Sender: TObject);
    procedure ButtonS2Click(Sender: TObject);
    procedure DrawGridQ1DrawCell(Sender: TObject; Col, Row: Longint;
      Rect: TRect; State: TGridDrawState);
  private
    { Private declarations }
    PictureHeight: Integer;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormShow(Sender: TObject);
var i,k: Integer;
    SrcRec: TSearchRec;
begin
  with Dsp.Queue do begin
     {AddObject('AAAA',nil);}
     OnChange := QueueChange;
     end;

  k:=FindFirst('PICTURES\*.bmp',faAnyFile,SrcRec);
  while k=0 do
    begin
    ListBoxS1.Items.Add(AnsiLowerCase(SrcRec.Name));
    k:=FindNext(SrcRec);
    end;
  {
  k:=FindFirst('PICTURES\*.ico',faAnyFile,SrcRec);
  while k=0 do
    begin
    ListBoxS1.Items.Add(AnsiLowerCase(SrcRec.Name));
    k:=FindNext(SrcRec);
    end;
  }
  ListBoxS1.ItemIndex := 0;
  ImageS1.Picture.LoadFromFile('PICTURES\'+ListBoxS1.Items[ListBoxS1.ItemIndex]);
  PictureHeight:=24; { should be evaluated }

  ListBoxS2.ItemIndex := 0;
  ListBoxS3.ItemIndex := 0;

  EditQ1.Text := IntToStr(Dsp.Count);
  DisplayEnabled;
  DrawGridQ1.DefaultRowHeight:=PictureHeight+10;
  {DrawGridQ1.RowCount:= Dsp.Count+1;}
end;

procedure TForm1.QueueChange(Sender: TObject);
begin
  EditQ1.Text := IntToStr(Dsp.Count);
  {DrawGridQ1.RowCount:= Dsp.Count+1;}
  DrawGridQ1.Refresh;
end;

procedure TForm1.ButtonS1Click(Sender: TObject); { BitBtnAdd }
var Obj:TPicture;
begin
  Obj := TPicture.Create;
  Obj.Assign(ImageS1.Picture);
  Dsp.Queue.AddObject(ListBoxS2.Items[ListBoxS2.ItemIndex],Obj);
end;

procedure TForm1.ListBoxS1Click(Sender: TObject);
begin
  ImageS1.Picture.LoadFromFile('PICTURES\'+ListBoxS1.Items[ListBoxS1.ItemIndex]);  
end;

procedure TForm1.DspDispatch(Sender:TObject; Ident:String; Environ:TObject);
var ret:Integer;
begin
  { for Form2: }
  PictureObject := Environ as TPicture;
  ExecName := Ident;
  Action := ListBoxS3.Items[ListBoxS3.ItemIndex];
  ret := Form2.ShowModal;
  if ret = mrYes then Dsp.Enabled:=False;
  DisplayEnabled;
end;

procedure TForm1.ButtonS3Click(Sender: TObject); { Start }
begin
  Dsp.Enabled:=True;
  DisplayEnabled;
end;

procedure TForm1.ButtonS4Click(Sender: TObject);  { Stop  }
begin
  Dsp.Enabled:=False;
  DisplayEnabled;
end;

procedure TForm1.DisplayEnabled;
begin
  if Dsp.Enabled then begin
    EditQ2.Text:='True';
    ButtonS3.Enabled:=False;
    ButtonS4.Enabled:=True;
    end
  else begin
    EditQ2.Text:='False';
    ButtonS3.Enabled:=True;
    ButtonS4.Enabled:=False;
    end;
end;

procedure TForm1.ButtonS2Click(Sender: TObject); { BitBtnDel }
begin
  if (DrawGridQ1.Row > 0) and (DrawGridQ1.Row <= Dsp.Count) then
    Dsp.Queue.Delete(DrawGridQ1.Row - 1)
  else ShowMessage('No Queue element selected');
end;

procedure TForm1.DrawGridQ1DrawCell(Sender: TObject; Col, Row: Longint;
  Rect: TRect; State: TGridDrawState);
begin
  if Row=0 then begin { State=gdFixed}
    if Col=0 then DrawGridQ1.Canvas.TextOut(Rect.Left+5,Rect.Top+2,'Ident');
    if Col=1 then DrawGridQ1.Canvas.TextOut(Rect.Left+5,Rect.Top+2,'Object');
    end
  else if Row <= Dsp.Count then begin
    if Col=0 then DrawGridQ1.Canvas.TextOut(Rect.Left+5,Rect.Top+5,
       Dsp.Queue.Strings[Row-1]);
    if (Col=1) and (Dsp.Queue.Objects[Row-1] <> nil) then 
       DrawGridQ1.Canvas.Draw(Rect.Left+5,Rect.Top+5,
         (Dsp.Queue.Objects[Row-1] as TPicture).Graphic);
    end
end;

end.
 